#!/usr/bin/python

class WriteOnly(object):
	def __init__(self, name):
		print "Called init with %s" % name
		self.__name = name
		self.__value = None
		self.__writable = True
	
	def __get__(self, obj, objtype):
		print "Called get against %s (val: %s)" % (self.__name, self.__value)
		return self.__value

	def __set__(self, obj, value):
		print "Called set against %s with %s (was: %s)" % (self.__name, value, self.__value)
		if self.__writable:
			self.__value = value
			self.__writable =  False
		else:
			msg = "Can't reset %s from %s to %s" % (self.__name, repr(self.__value), repr(value))

class Foo(object):
	bar = WriteOnly('bar')
	baz = WriteOnly('baz')
	quux = WriteOnly('quux')

foo = Foo()
foo.bar = 4
foo.bar = 7
print foo.quux
